com.fasterxml.jackson.databind

## Class PropertyNamingStrategy

- java.lang.Object
- - com.fasterxml.jackson.databind.PropertyNamingStrategy

All Implemented Interfaces:
  Serializable

Direct Known Subclasses:
  PropertyNamingStrategies.NamingBase

    public class PropertyNamingStrategy
    extends Object
    implements Serializable

Class that defines how names of JSON properties ("external names") are derived from names of POJO methods and fields ("internal names"), in cases where no explicit annotations exist for naming. Methods are passed information about POJO member for which name is needed, as well as default name that would be used if no custom strategy was used.

Default (empty) implementation returns suggested ("implicit" or "default") name unmodified

Note that the strategy is guaranteed to be called once per logical property (which may be represented by multiple members; such as pair of a getter and a setter), but may be called for each: implementations should not count on exact number of times, and should work for any member that represent a property. Also note that calls are made during construction of serializers and deserializers which are typically cached, and not for every time serializer or deserializer is called.

In absence of a registered custom strategy, the default Java property naming strategy is used, which leaves field names as is, and removes set/get/is prefix from methods (as well as lower-cases initial sequence of capitalized characters).

NOTE! Since 2.12 up until 2.19, sub-classes defined here (as well as static singleton instances thereof) were deprecated due to databind#2715. They were removed in 2.20. Please use constants and classes in `PropertyNamingStrategies` instead. In particular, `PropertyNamingStrategies.NamingBase` is the base class to use.

See Also:
  Serialized Form

### Constructor Summary

Constructors
Constructor and Description
`PropertyNamingStrategy()`

### Method Summary

All Methods Instance Methods Concrete Methods
`String` `nameForConstructorParameter(MapperConfig<?> config, AnnotatedParameter ctorParam, String defaultName)` Method called to find external name (name used in JSON) for given logical POJO property, as defined by given constructor parameter; typically called when building a deserializer (but not necessarily only then).
`String` `nameForField(MapperConfig<?> config, AnnotatedField field, String defaultName)` Method called to find external name (name used in JSON) for given logical POJO property, as defined by given field.
`String` `nameForGetterMethod(MapperConfig<?> config, AnnotatedMethod method, String defaultName)` Method called to find external name (name used in JSON) for given logical POJO property, as defined by given getter method; typically called when building a serializer.
`String` `nameForSetterMethod(MapperConfig<?> config, AnnotatedMethod method, String defaultName)` Method called to find external name (name used in JSON) for given logical POJO property, as defined by given setter method; typically called when building a deserializer (but not necessarily only then).

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### PropertyNamingStrategy

    public PropertyNamingStrategy()

### Method Detail

#### nameForField

    public String nameForField(MapperConfig<?> config,
                               AnnotatedField field,
                               String defaultName)

Method called to find external name (name used in JSON) for given logical POJO property, as defined by given field.

Parameters:
  `config` - Configuration in used: either `SerializationConfig` or `DeserializationConfig`, depending on whether method is called during serialization or deserialization
  `field` - Field used to access property
  `defaultName` - Default name that would be used for property in absence of custom strategy
Returns:
  Logical name to use for property that the field represents

#### nameForGetterMethod

    public String nameForGetterMethod(MapperConfig<?> config,
                                      AnnotatedMethod method,
                                      String defaultName)

Method called to find external name (name used in JSON) for given logical POJO property, as defined by given getter method; typically called when building a serializer. (but not always -- when using "getter-as-setter", may be called during deserialization)

Parameters:
  `config` - Configuration in used: either `SerializationConfig` or `DeserializationConfig`, depending on whether method is called during serialization or deserialization
  `method` - Method used to access property.
  `defaultName` - Default name that would be used for property in absence of custom strategy
Returns:
  Logical name to use for property that the method represents

#### nameForSetterMethod

    public String nameForSetterMethod(MapperConfig<?> config,
                                      AnnotatedMethod method,
                                      String defaultName)

Method called to find external name (name used in JSON) for given logical POJO property, as defined by given setter method; typically called when building a deserializer (but not necessarily only then).

Parameters:
  `config` - Configuration in used: either `SerializationConfig` or `DeserializationConfig`, depending on whether method is called during serialization or deserialization
  `method` - Method used to access property.
  `defaultName` - Default name that would be used for property in absence of custom strategy
Returns:
  Logical name to use for property that the method represents

#### nameForConstructorParameter

    public String nameForConstructorParameter(MapperConfig<?> config,
                                              AnnotatedParameter ctorParam,
                                              String defaultName)

Method called to find external name (name used in JSON) for given logical POJO property, as defined by given constructor parameter; typically called when building a deserializer (but not necessarily only then).

Parameters:
  `config` - Configuration in used: either `SerializationConfig` or `DeserializationConfig`, depending on whether method is called during serialization or deserialization
  `ctorParam` - Constructor parameter used to pass property.
  `defaultName` - Default name that would be used for property in absence of custom strategy